# coding: utf-8

"""
    Opal API

    The Opal API is a RESTful API that allows you to interact with the Opal Security platform programmatically.

    The version of the OpenAPI document: 1.0
    Contact: hello@opal.dev
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import json
from enum import Enum
from typing_extensions import Self


class ResourceTypeEnum(str, Enum):
    """
    The type of the resource.
    """

    """
    allowed enum values
    """
    AWS_IAM_ROLE = 'AWS_IAM_ROLE'
    AWS_EC2_INSTANCE = 'AWS_EC2_INSTANCE'
    AWS_EKS_CLUSTER = 'AWS_EKS_CLUSTER'
    AWS_RDS_POSTGRES_CLUSTER = 'AWS_RDS_POSTGRES_CLUSTER'
    AWS_RDS_POSTGRES_INSTANCE = 'AWS_RDS_POSTGRES_INSTANCE'
    AWS_RDS_MYSQL_CLUSTER = 'AWS_RDS_MYSQL_CLUSTER'
    AWS_RDS_MYSQL_INSTANCE = 'AWS_RDS_MYSQL_INSTANCE'
    AWS_ACCOUNT = 'AWS_ACCOUNT'
    AWS_SSO_PERMISSION_SET = 'AWS_SSO_PERMISSION_SET'
    AZURE_MANAGEMENT_GROUP = 'AZURE_MANAGEMENT_GROUP'
    AZURE_RESOURCE_GROUP = 'AZURE_RESOURCE_GROUP'
    AZURE_SUBSCRIPTION = 'AZURE_SUBSCRIPTION'
    AZURE_VIRTUAL_MACHINE = 'AZURE_VIRTUAL_MACHINE'
    AZURE_STORAGE_ACCOUNT = 'AZURE_STORAGE_ACCOUNT'
    AZURE_STORAGE_CONTAINER = 'AZURE_STORAGE_CONTAINER'
    AZURE_SQL_SERVER = 'AZURE_SQL_SERVER'
    AZURE_SQL_MANAGED_INSTANCE = 'AZURE_SQL_MANAGED_INSTANCE'
    AZURE_SQL_DATABASE = 'AZURE_SQL_DATABASE'
    AZURE_SQL_MANAGED_DATABASE = 'AZURE_SQL_MANAGED_DATABASE'
    AZURE_USER_ASSIGNED_MANAGED_IDENTITY = 'AZURE_USER_ASSIGNED_MANAGED_Identity'
    AZURE_ENTRA_ID_ROLE = 'AZURE_ENTRA_ID_ROLE'
    AZURE_ENTERPRISE_APP = 'AZURE_ENTERPRISE_APP'
    CUSTOM = 'CUSTOM'
    CUSTOM_CONNECTOR = 'CUSTOM_CONNECTOR'
    DATABRICKS_ACCOUNT_SERVICE_PRINCIPAL = 'DATABRICKS_ACCOUNT_SERVICE_PRINCIPAL'
    GCP_ORGANIZATION = 'GCP_ORGANIZATION'
    GCP_BUCKET = 'GCP_BUCKET'
    GCP_COMPUTE_INSTANCE = 'GCP_COMPUTE_INSTANCE'
    GCP_FOLDER = 'GCP_FOLDER'
    GCP_GKE_CLUSTER = 'GCP_GKE_CLUSTER'
    GCP_PROJECT = 'GCP_PROJECT'
    GCP_CLOUD_SQL_POSTGRES_INSTANCE = 'GCP_CLOUD_SQL_POSTGRES_INSTANCE'
    GCP_CLOUD_SQL_MYSQL_INSTANCE = 'GCP_CLOUD_SQL_MYSQL_INSTANCE'
    GCP_BIG_QUERY_DATASET = 'GCP_BIG_QUERY_DATASET'
    GCP_BIG_QUERY_TABLE = 'GCP_BIG_QUERY_TABLE'
    GCP_SERVICE_ACCOUNT = 'GCP_SERVICE_ACCOUNT'
    GIT_HUB_REPO = 'GIT_HUB_REPO'
    GIT_LAB_PROJECT = 'GIT_LAB_PROJECT'
    GOOGLE_WORKSPACE_ROLE = 'GOOGLE_WORKSPACE_ROLE'
    MONGO_INSTANCE = 'MONGO_INSTANCE'
    MONGO_ATLAS_INSTANCE = 'MONGO_ATLAS_INSTANCE'
    OKTA_APP = 'OKTA_APP'
    OKTA_ROLE = 'OKTA_ROLE'
    OPAL_ROLE = 'OPAL_ROLE'
    OPAL_SCOPED_ROLE = 'OPAL_SCOPED_ROLE'
    PAGERDUTY_ROLE = 'PAGERDUTY_ROLE'
    TAILSCALE_SSH = 'TAILSCALE_SSH'
    SALESFORCE_PERMISSION_SET = 'SALESFORCE_PERMISSION_SET'
    SALESFORCE_PROFILE = 'SALESFORCE_PROFILE'
    SALESFORCE_ROLE = 'SALESFORCE_ROLE'
    SNOWFLAKE_DATABASE = 'SNOWFLAKE_DATABASE'
    SNOWFLAKE_SCHEMA = 'SNOWFLAKE_SCHEMA'
    SNOWFLAKE_TABLE = 'SNOWFLAKE_TABLE'
    WORKDAY_ROLE = 'WORKDAY_ROLE'
    MYSQL_INSTANCE = 'MYSQL_INSTANCE'
    MARIADB_INSTANCE = 'MARIADB_INSTANCE'
    POSTGRES_INSTANCE = 'POSTGRES_INSTANCE'
    TELEPORT_ROLE = 'TELEPORT_ROLE'

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Create an instance of ResourceTypeEnum from a JSON string"""
        return cls(json.loads(json_str))


